// TLock structure contains time for ON and OFF state of the relay,
//   as well as flag which notifies if changes are made

struct TLock{
  char on_seconds, on_minutes, on_hours;
  char off_seconds, off_minutes, off_hours;
  char modified;
} Locks[4];  // we will use 4 relays/locks

char seconds, old_seconds, minutes, hours, day, month, year;

// LCD module connections
sbit Soft_I2C_Scl_Output         at PORTD3_bit;
sbit Soft_I2C_Sda_Output         at PORTD4_bit;
sbit Soft_I2C_Scl_Input          at PIND3_bit;
sbit Soft_I2C_Sda_Input          at PIND4_bit;
sbit Soft_I2C_Scl_Direction      at DDD3_bit;
sbit Soft_I2C_Sda_Direction      at DDD4_bit;
// End Software I2C connections

// LCD module connections
sbit    LCD_RS at PORTB.B2;
sbit    LCD_EN at PORTB.B3;
sbit    LCD_D4 at PORTB.B4;
sbit    LCD_D5 at PORTB.B5;
sbit    LCD_D6 at PORTB.B6;
sbit    LCD_D7 at PORTB.B7;
sbit    LCD_RS_Direction  at DDRB.B2;
sbit    LCD_EN_Direction  at DDRB.B3;
sbit    LCD_D4_Direction  at DDRB.B4;
sbit    LCD_D5_Direction  at DDRB.B5;
sbit    LCD_D6_Direction  at DDRB.B6;
 sbit   LCD_D7_Direction  at DDRB.B7;

// Keypad module connections
char keypadPort at PORTC;
char keypadPort_Direction at DDRC;
// End Keypad module connections

// few auxiliary variables
char kp, ShowTime, SetupTime, noChange;
char index, CurrentLock;

// Performs project-wide initialization
void Init_All(){
  PORTA = 0x00;               // Initially all relays are off
  DDRA  = 0xFF;               // PORTA is output (relays)

  Soft_I2C_Init();            // Initialize Soft I2C communication

  Lcd_Init();                 // Initialize LCD
  Lcd_Cmd(_LCD_CLEAR);        // Clear LCD display
  
  Keypad_Init();              // Initialize Keypad

  kp = 0;                     // Set globals to start values
  index = 0;
  ShowTime = 0;
  SetupTime = 0;
  noChange = 0xFF;
  
  for (CurrentLock = 0; CurrentLock <=3; CurrentLock++){     // initialize times to some meaningfull values
     Locks[CurrentLock].on_hours    = 10;
     Locks[CurrentLock].on_minutes  = 37;
     Locks[CurrentLock].on_seconds  = 1  + CurrentLock;
     Locks[CurrentLock].off_hours   = 10;
     Locks[CurrentLock].off_minutes = 37;
     Locks[CurrentLock].off_seconds = 30 + CurrentLock;
     Locks[CurrentLock].modified    = 0xFF;
   }

  CurrentLock = 0;           // Position to the first lock
}